/**
 */
package de.mdelab.sdm.interpreter.core.executionTrace.impl;

import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.mdelab.sdm.interpreter.core.executionTrace.ActivityEdgeTraversal;
import de.mdelab.sdm.interpreter.core.executionTrace.ActivityExecution;
import de.mdelab.sdm.interpreter.core.executionTrace.ActivityNodeExecution;
import de.mdelab.sdm.interpreter.core.executionTrace.AttributeValueSet;
import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTrace;
import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTraceFactory;
import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTracePackage;
import de.mdelab.sdm.interpreter.core.executionTrace.ExpressionEvaluation;
import de.mdelab.sdm.interpreter.core.executionTrace.InstanceLinkCreation;
import de.mdelab.sdm.interpreter.core.executionTrace.InstanceLinkDeletion;
import de.mdelab.sdm.interpreter.core.executionTrace.InstanceObjectCreation;
import de.mdelab.sdm.interpreter.core.executionTrace.InstanceObjectDeletion;
import de.mdelab.sdm.interpreter.core.executionTrace.LinkCheckFailed;
import de.mdelab.sdm.interpreter.core.executionTrace.LinkCheckSuccessful;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternApplication;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternConstraintHolds;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternConstraintViolated;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternInitialization;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternMatching;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternObjectBindingRevoked;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternObjectBound;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternObjectConstraintHolds;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternObjectConstraintViolated;
import de.mdelab.sdm.interpreter.core.executionTrace.StoryPatternObjectNotBound;
import de.mdelab.sdm.interpreter.core.executionTrace.TraversingLink;
import de.mdelab.sdm.interpreter.core.executionTrace.VariableChanged;
import de.mdelab.sdm.interpreter.core.executionTrace.VariableCreated;
import de.mdelab.sdm.interpreter.core.executionTrace.VariableDeleted;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class ExecutionTraceFactoryImpl extends EFactoryImpl implements ExecutionTraceFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public static ExecutionTraceFactory init() {
		try {
			ExecutionTraceFactory theExecutionTraceFactory = (ExecutionTraceFactory) EPackage.Registry.INSTANCE
					.getEFactory(ExecutionTracePackage.eNS_URI);
			if (theExecutionTraceFactory != null) {
				return theExecutionTraceFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ExecutionTraceFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public ExecutionTraceFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case ExecutionTracePackage.MAP_ENTRY:
			return (EObject) createMapEntry();
		case ExecutionTracePackage.EXECUTION_TRACE:
			return createExecutionTrace();
		case ExecutionTracePackage.ACTIVITY_EXECUTION:
			return createActivityExecution();
		case ExecutionTracePackage.ACTIVITY_NODE_EXECUTION:
			return createActivityNodeExecution();
		case ExecutionTracePackage.ACTIVITY_EDGE_TRAVERSAL:
			return createActivityEdgeTraversal();
		case ExecutionTracePackage.STORY_PATTERN_INITIALIZATION:
			return createStoryPatternInitialization();
		case ExecutionTracePackage.STORY_PATTERN_MATCHING:
			return createStoryPatternMatching();
		case ExecutionTracePackage.STORY_PATTERN_APPLICATION:
			return createStoryPatternApplication();
		case ExecutionTracePackage.STORY_PATTERN_OBJECT_BOUND:
			return createStoryPatternObjectBound();
		case ExecutionTracePackage.STORY_PATTERN_OBJECT_NOT_BOUND:
			return createStoryPatternObjectNotBound();
		case ExecutionTracePackage.STORY_PATTERN_OBJECT_BINDING_REVOKED:
			return createStoryPatternObjectBindingRevoked();
		case ExecutionTracePackage.TRAVERSING_LINK:
			return createTraversingLink();
		case ExecutionTracePackage.LINK_CHECK_SUCCESSFUL:
			return createLinkCheckSuccessful();
		case ExecutionTracePackage.LINK_CHECK_FAILED:
			return createLinkCheckFailed();
		case ExecutionTracePackage.EXPRESSION_EVALUATION:
			return createExpressionEvaluation();
		case ExecutionTracePackage.INSTANCE_OBJECT_CREATION:
			return createInstanceObjectCreation();
		case ExecutionTracePackage.INSTANCE_OBJECT_DELETION:
			return createInstanceObjectDeletion();
		case ExecutionTracePackage.INSTANCE_LINK_CREATION:
			return createInstanceLinkCreation();
		case ExecutionTracePackage.INSTANCE_LINK_DELETION:
			return createInstanceLinkDeletion();
		case ExecutionTracePackage.ATTRIBUTE_VALUE_SET:
			return createAttributeValueSet();
		case ExecutionTracePackage.VARIABLE_CREATED:
			return createVariableCreated();
		case ExecutionTracePackage.VARIABLE_DELETED:
			return createVariableDeleted();
		case ExecutionTracePackage.VARIABLE_CHANGED:
			return createVariableChanged();
		case ExecutionTracePackage.STORY_PATTERN_OBJECT_CONSTRAINT_HOLDS:
			return createStoryPatternObjectConstraintHolds();
		case ExecutionTracePackage.STORY_PATTERN_OBJECT_CONSTRAINT_VIOLATED:
			return createStoryPatternObjectConstraintViolated();
		case ExecutionTracePackage.STORY_PATTERN_CONSTRAINT_HOLDS:
			return createStoryPatternConstraintHolds();
		case ExecutionTracePackage.STORY_PATTERN_CONSTRAINT_VIOLATED:
			return createStoryPatternConstraintViolated();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public <KeyType, ValueType> Map.Entry<KeyType, ValueType> createMapEntry() {
		MapEntryImpl<KeyType, ValueType> mapEntry = new MapEntryImpl<KeyType, ValueType>();
		return mapEntry;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExecutionTrace createExecutionTrace() {
		ExecutionTraceImpl executionTrace = new ExecutionTraceImpl();
		return executionTrace;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ActivityType> ActivityExecution<ActivityType> createActivityExecution() {
		ActivityExecutionImpl<ActivityType> activityExecution = new ActivityExecutionImpl<ActivityType>();
		return activityExecution;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ActivityNodeType> ActivityNodeExecution<ActivityNodeType> createActivityNodeExecution() {
		ActivityNodeExecutionImpl<ActivityNodeType> activityNodeExecution = new ActivityNodeExecutionImpl<ActivityNodeType>();
		return activityNodeExecution;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ActivityEdgeType> ActivityEdgeTraversal<ActivityEdgeType> createActivityEdgeTraversal() {
		ActivityEdgeTraversalImpl<ActivityEdgeType> activityEdgeTraversal = new ActivityEdgeTraversalImpl<ActivityEdgeType>();
		return activityEdgeTraversal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternType> StoryPatternInitialization<StoryPatternType> createStoryPatternInitialization() {
		StoryPatternInitializationImpl<StoryPatternType> storyPatternInitialization = new StoryPatternInitializationImpl<StoryPatternType>();
		return storyPatternInitialization;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternType> StoryPatternMatching<StoryPatternType> createStoryPatternMatching() {
		StoryPatternMatchingImpl<StoryPatternType> storyPatternMatching = new StoryPatternMatchingImpl<StoryPatternType>();
		return storyPatternMatching;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternType> StoryPatternApplication<StoryPatternType> createStoryPatternApplication() {
		StoryPatternApplicationImpl<StoryPatternType> storyPatternApplication = new StoryPatternApplicationImpl<StoryPatternType>();
		return storyPatternApplication;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType> StoryPatternObjectBound<StoryPatternObjectType> createStoryPatternObjectBound() {
		StoryPatternObjectBoundImpl<StoryPatternObjectType> storyPatternObjectBound = new StoryPatternObjectBoundImpl<StoryPatternObjectType>();
		return storyPatternObjectBound;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType> StoryPatternObjectNotBound<StoryPatternObjectType> createStoryPatternObjectNotBound() {
		StoryPatternObjectNotBoundImpl<StoryPatternObjectType> storyPatternObjectNotBound = new StoryPatternObjectNotBoundImpl<StoryPatternObjectType>();
		return storyPatternObjectNotBound;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType> StoryPatternObjectBindingRevoked<StoryPatternObjectType> createStoryPatternObjectBindingRevoked() {
		StoryPatternObjectBindingRevokedImpl<StoryPatternObjectType> storyPatternObjectBindingRevoked = new StoryPatternObjectBindingRevokedImpl<StoryPatternObjectType>();
		return storyPatternObjectBindingRevoked;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternLinkType, StoryPatternObjectType> TraversingLink<StoryPatternLinkType, StoryPatternObjectType> createTraversingLink() {
		TraversingLinkImpl<StoryPatternLinkType, StoryPatternObjectType> traversingLink = new TraversingLinkImpl<StoryPatternLinkType, StoryPatternObjectType>();
		return traversingLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternLinkType, StoryPatternObjectType> LinkCheckSuccessful<StoryPatternLinkType, StoryPatternObjectType> createLinkCheckSuccessful() {
		LinkCheckSuccessfulImpl<StoryPatternLinkType, StoryPatternObjectType> linkCheckSuccessful = new LinkCheckSuccessfulImpl<StoryPatternLinkType, StoryPatternObjectType>();
		return linkCheckSuccessful;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternLinkType, StoryPatternObjectType> LinkCheckFailed<StoryPatternLinkType, StoryPatternObjectType> createLinkCheckFailed() {
		LinkCheckFailedImpl<StoryPatternLinkType, StoryPatternObjectType> linkCheckFailed = new LinkCheckFailedImpl<StoryPatternLinkType, StoryPatternObjectType>();
		return linkCheckFailed;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ExpressionType> ExpressionEvaluation<ExpressionType> createExpressionEvaluation() {
		ExpressionEvaluationImpl<ExpressionType> expressionEvaluation = new ExpressionEvaluationImpl<ExpressionType>();
		return expressionEvaluation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType> InstanceObjectCreation<StoryPatternObjectType> createInstanceObjectCreation() {
		InstanceObjectCreationImpl<StoryPatternObjectType> instanceObjectCreation = new InstanceObjectCreationImpl<StoryPatternObjectType>();
		return instanceObjectCreation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType> InstanceObjectDeletion<StoryPatternObjectType> createInstanceObjectDeletion() {
		InstanceObjectDeletionImpl<StoryPatternObjectType> instanceObjectDeletion = new InstanceObjectDeletionImpl<StoryPatternObjectType>();
		return instanceObjectDeletion;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternLinkType, StoryPatternObjectType> InstanceLinkCreation<StoryPatternLinkType, StoryPatternObjectType> createInstanceLinkCreation() {
		InstanceLinkCreationImpl<StoryPatternLinkType, StoryPatternObjectType> instanceLinkCreation = new InstanceLinkCreationImpl<StoryPatternLinkType, StoryPatternObjectType>();
		return instanceLinkCreation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternLinkType, StoryPatternObjectType> InstanceLinkDeletion<StoryPatternLinkType, StoryPatternObjectType> createInstanceLinkDeletion() {
		InstanceLinkDeletionImpl<StoryPatternLinkType, StoryPatternObjectType> instanceLinkDeletion = new InstanceLinkDeletionImpl<StoryPatternLinkType, StoryPatternObjectType>();
		return instanceLinkDeletion;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType, FeatureType> AttributeValueSet<StoryPatternObjectType, FeatureType> createAttributeValueSet() {
		AttributeValueSetImpl<StoryPatternObjectType, FeatureType> attributeValueSet = new AttributeValueSetImpl<StoryPatternObjectType, FeatureType>();
		return attributeValueSet;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ClassifierType> VariableCreated<ClassifierType> createVariableCreated() {
		VariableCreatedImpl<ClassifierType> variableCreated = new VariableCreatedImpl<ClassifierType>();
		return variableCreated;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ClassifierType> VariableDeleted<ClassifierType> createVariableDeleted() {
		VariableDeletedImpl<ClassifierType> variableDeleted = new VariableDeletedImpl<ClassifierType>();
		return variableDeleted;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <ClassifierType> VariableChanged<ClassifierType> createVariableChanged() {
		VariableChangedImpl<ClassifierType> variableChanged = new VariableChangedImpl<ClassifierType>();
		return variableChanged;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType, ExpressionType> StoryPatternObjectConstraintHolds<StoryPatternObjectType, ExpressionType> createStoryPatternObjectConstraintHolds() {
		StoryPatternObjectConstraintHoldsImpl<StoryPatternObjectType, ExpressionType> storyPatternObjectConstraintHolds = new StoryPatternObjectConstraintHoldsImpl<StoryPatternObjectType, ExpressionType>();
		return storyPatternObjectConstraintHolds;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternObjectType, ExpressionType> StoryPatternObjectConstraintViolated<StoryPatternObjectType, ExpressionType> createStoryPatternObjectConstraintViolated() {
		StoryPatternObjectConstraintViolatedImpl<StoryPatternObjectType, ExpressionType> storyPatternObjectConstraintViolated = new StoryPatternObjectConstraintViolatedImpl<StoryPatternObjectType, ExpressionType>();
		return storyPatternObjectConstraintViolated;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternType, ExpressionType> StoryPatternConstraintHolds<StoryPatternType, ExpressionType> createStoryPatternConstraintHolds() {
		StoryPatternConstraintHoldsImpl<StoryPatternType, ExpressionType> storyPatternConstraintHolds = new StoryPatternConstraintHoldsImpl<StoryPatternType, ExpressionType>();
		return storyPatternConstraintHolds;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public <StoryPatternType, ExpressionType> StoryPatternConstraintViolated<StoryPatternType, ExpressionType> createStoryPatternConstraintViolated() {
		StoryPatternConstraintViolatedImpl<StoryPatternType, ExpressionType> storyPatternConstraintViolated = new StoryPatternConstraintViolatedImpl<StoryPatternType, ExpressionType>();
		return storyPatternConstraintViolated;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExecutionTracePackage getExecutionTracePackage() {
		return (ExecutionTracePackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ExecutionTracePackage getPackage() {
		return ExecutionTracePackage.eINSTANCE;
	}

} // ExecutionTraceFactoryImpl
