/**
 */
package de.mdelab.sdm.interpreter.core.executionTrace.impl;

import java.util.Collection;
import java.util.concurrent.TimeUnit;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import de.mdelab.sdm.interpreter.core.executionTrace.Execution;
import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTrace;
import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTracePackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Execution Trace</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.sdm.interpreter.core.executionTrace.impl.ExecutionTraceImpl#getExecutions <em>Executions</em>}</li>
 *   <li>{@link de.mdelab.sdm.interpreter.core.executionTrace.impl.ExecutionTraceImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.mdelab.sdm.interpreter.core.executionTrace.impl.ExecutionTraceImpl#getTotalExecutionTime <em>Total Execution Time</em>}</li>
 *   <li>{@link de.mdelab.sdm.interpreter.core.executionTrace.impl.ExecutionTraceImpl#getTotalExecutionTimeMsec <em>Total Execution Time Msec</em>}</li>
 *   <li>{@link de.mdelab.sdm.interpreter.core.executionTrace.impl.ExecutionTraceImpl#getName <em>Name</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ExecutionTraceImpl extends EObjectImpl implements ExecutionTrace {
	/**
	 * The cached value of the '{@link #getExecutions() <em>Executions</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getExecutions()
	 * @generated
	 * @ordered
	 */
	protected EList<Execution> executions;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getTotalExecutionTime() <em>Total Execution Time</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getTotalExecutionTime()
	 * @generated
	 * @ordered
	 */
	protected static final long TOTAL_EXECUTION_TIME_EDEFAULT = 0L;

	/**
	 * The default value of the '{@link #getTotalExecutionTimeMsec() <em>Total Execution Time Msec</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTotalExecutionTimeMsec()
	 * @generated
	 * @ordered
	 */
	protected static final long TOTAL_EXECUTION_TIME_MSEC_EDEFAULT = 0L;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ExecutionTraceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ExecutionTracePackage.Literals.EXECUTION_TRACE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Execution> getExecutions() {
		if (executions == null) {
			executions = new EObjectContainmentEList<Execution>(Execution.class, this,
					ExecutionTracePackage.EXECUTION_TRACE__EXECUTIONS);
		}
		return executions;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ExecutionTracePackage.EXECUTION_TRACE__DESCRIPTION,
					oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public long getTotalExecutionTime() {
		long sum = 0;

		for (final Execution execution : this.getExecutions()) {
			sum += execution.getExecutionTime();
		}

		return sum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public long getTotalExecutionTimeMsec() {
		return TimeUnit.NANOSECONDS.toMillis(this.getTotalExecutionTime());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ExecutionTracePackage.EXECUTION_TRACE__NAME, oldName,
					name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case ExecutionTracePackage.EXECUTION_TRACE__EXECUTIONS:
			return ((InternalEList<?>) getExecutions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case ExecutionTracePackage.EXECUTION_TRACE__EXECUTIONS:
			return getExecutions();
		case ExecutionTracePackage.EXECUTION_TRACE__DESCRIPTION:
			return getDescription();
		case ExecutionTracePackage.EXECUTION_TRACE__TOTAL_EXECUTION_TIME:
			return getTotalExecutionTime();
		case ExecutionTracePackage.EXECUTION_TRACE__TOTAL_EXECUTION_TIME_MSEC:
			return getTotalExecutionTimeMsec();
		case ExecutionTracePackage.EXECUTION_TRACE__NAME:
			return getName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case ExecutionTracePackage.EXECUTION_TRACE__EXECUTIONS:
			getExecutions().clear();
			getExecutions().addAll((Collection<? extends Execution>) newValue);
			return;
		case ExecutionTracePackage.EXECUTION_TRACE__DESCRIPTION:
			setDescription((String) newValue);
			return;
		case ExecutionTracePackage.EXECUTION_TRACE__NAME:
			setName((String) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case ExecutionTracePackage.EXECUTION_TRACE__EXECUTIONS:
			getExecutions().clear();
			return;
		case ExecutionTracePackage.EXECUTION_TRACE__DESCRIPTION:
			setDescription(DESCRIPTION_EDEFAULT);
			return;
		case ExecutionTracePackage.EXECUTION_TRACE__NAME:
			setName(NAME_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case ExecutionTracePackage.EXECUTION_TRACE__EXECUTIONS:
			return executions != null && !executions.isEmpty();
		case ExecutionTracePackage.EXECUTION_TRACE__DESCRIPTION:
			return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
		case ExecutionTracePackage.EXECUTION_TRACE__TOTAL_EXECUTION_TIME:
			return getTotalExecutionTime() != TOTAL_EXECUTION_TIME_EDEFAULT;
		case ExecutionTracePackage.EXECUTION_TRACE__TOTAL_EXECUTION_TIME_MSEC:
			return getTotalExecutionTimeMsec() != TOTAL_EXECUTION_TIME_MSEC_EDEFAULT;
		case ExecutionTracePackage.EXECUTION_TRACE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} // ExecutionTraceImpl
