package de.mdelab.sdm.interpreter.core.executionTrace.presentation;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider;
import org.eclipse.jface.viewers.ILazyTreeContentProvider;

public class LazyAdapterFactoryTreeContentProvider extends AdapterFactoryContentProvider implements ILazyTreeContentProvider {

	public LazyAdapterFactoryTreeContentProvider( final AdapterFactory p_adapterFactory ) {
		super( p_adapterFactory );
	}

	@Override
	public void updateElement(	final Object p_parent,
								final int pi_index ) {
		final Object[] children = getChildren( p_parent );

		final Object childAtIndex = children[ pi_index ];
		
		if ( childAtIndex != null ) {
			getViewer().replace( p_parent, pi_index, childAtIndex );
			updateChildCount( p_parent, children.length );
			getViewer().updatePlus( childAtIndex );
		}
	}

	@Override
	public void updateChildCount(	final Object p_element,
									final int pi_currentChildCount ) {
		final Object[] children = getChildren( p_element );
		final int actualCount = children.length;

		if ( actualCount != pi_currentChildCount ) {
			getViewer().setChildCount( p_element, actualCount );
		}
	}

	protected ExecutionTraceTreeViewer getViewer() {
		return (ExecutionTraceTreeViewer) viewer;
	}
}
