/**
 */
package de.mdelab.sdm.interpreter.core.executionTrace.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTracePackage;
import de.mdelab.sdm.interpreter.core.executionTrace.ExpressionEvaluation;

/**
 * This is the item provider adapter for a {@link de.mdelab.sdm.interpreter.core.executionTrace.ExpressionEvaluation} object.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class ExpressionEvaluationItemProvider extends ExecutionItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ExpressionEvaluationItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addExpressionPropertyDescriptor(object);
			addResultPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Expression feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addExpressionPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_ExpressionEvaluation_expression_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_ExpressionEvaluation_expression_feature",
								"_UI_ExpressionEvaluation_type"),
				ExecutionTracePackage.Literals.EXPRESSION_EVALUATION__EXPRESSION, true, false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Result feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addResultPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ExpressionEvaluation_result_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_ExpressionEvaluation_result_feature",
						"_UI_ExpressionEvaluation_type"),
				ExecutionTracePackage.Literals.EXPRESSION_EVALUATION__RESULT, true, false, false,
				ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns ExpressionEvaluation.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ExpressionEvaluation"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@Override
	public String getText(final Object object) {
//		String label = this.getString("_UI_ExpressionEvaluation_type") + " ";
//		final ExpressionEvaluation<?> expressionEvaluation = (ExpressionEvaluation<?>) object;
//
//		final ComposedAdapterFactory factory = new ComposedAdapterFactory(
//				EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());
//
//		if (expressionEvaluation.getExpression() != null) {
//			if (expressionEvaluation.getExpression() instanceof EObject) {
//				label += ((IItemLabelProvider) factory.adapt(expressionEvaluation.getExpression(),
//						IItemLabelProvider.class)).getText(expressionEvaluation.getExpression());
//			} else {
//				label += expressionEvaluation.getExpression().toString();
//			}
//		} else {
//			label += "[null]";
//		}
//
//		label += " ==> ";
//
//		if (expressionEvaluation.getResult() != null) {
//			label += expressionEvaluation.getResult();
//		} else {
//			label += "[null]";
//		}
//
//		return label;
		final StringBuilder strBuild = new StringBuilder( getString("_UI_ExpressionEvaluation_type") );
		strBuild.append( " " );
		final ExpressionEvaluation<?> expressionEvaluation = (ExpressionEvaluation<?>) object;
		strBuild.append( emfLabelProvider.getText( expressionEvaluation.getExpression() ) );			
		
		return strBuild.toString();
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ExpressionEvaluation.class)) {
		case ExecutionTracePackage.EXPRESSION_EVALUATION__EXPRESSION:
		case ExecutionTracePackage.EXPRESSION_EVALUATION__RESULT:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
